# NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
# https://openapi-generator.tech
# Do not edit the class manually.

defmodule FoyerAPI.Model.Share do
  @moduledoc """
  
  """

  @derive [Poison.Encoder]
  defstruct [
    :id,
    :seen,
    :receiverId,
    :senderId,
    :propertyId,
    :updatedAt,
    :createdAt,
    :Receiver,
    :Sender,
    :Property
  ]

  @type t :: %__MODULE__{
    :id => integer() | nil,
    :seen => boolean() | nil,
    :receiverId => integer() | nil,
    :senderId => integer() | nil,
    :propertyId => integer() | nil,
    :updatedAt => Date.t | nil,
    :createdAt => Date.t | nil,
    :Receiver => FoyerAPI.Model.User.t | nil,
    :Sender => FoyerAPI.Model.User.t | nil,
    :Property => FoyerAPI.Model.Property.t | nil
  }
end

defimpl Poison.Decoder, for: FoyerAPI.Model.Share do
  import FoyerAPI.Deserializer
  def decode(value, options) do
    value
    |> deserialize(:updatedAt, :date, nil, options)
    |> deserialize(:createdAt, :date, nil, options)
    |> deserialize(:Receiver, :struct, FoyerAPI.Model.User, options)
    |> deserialize(:Sender, :struct, FoyerAPI.Model.User, options)
    |> deserialize(:Property, :struct, FoyerAPI.Model.Property, options)
  end
end

